100 REMark Proportional Spacing printing
110 REMark by Dilwyn Jones Sep. 1997
120 :
130 REMark set up an example font (proportional version of QL font)
140 Setup_Proportional
150 :
160 CLS
170 t$ = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ abcdefghijklmnopqrstuvwxyz 1234567890'
180 PRINT 'Using Normal QL Fonts:'\t$\\ : REMark using normal font
190 :
200 REMark print same string using proportional font
210 CHAR_USE #1,font1,font2 : REMark switch #1 to new font
220 Prop_Print #1,'Using Proportional QL Font:' : PRINT
230 Prop_Print #1,t$ : PRINT \\ : REMark newlines
240 :
250 CHAR_USE #1,0,0  : REMark back to default font and reset spacing
260 RECHP font1      : REMark release heap memory used by above fonts
270 :
280 PRINT'Back to standard font:'\t$
290 :
300 STOP
310 :
320 DEFine PROCedure Prop_Print (channel,str$)
330   LOCal char
340   FOR char = 1 TO LEN(str$)
350     CHAR_INC #channel,prop%(CODE(str$(char))),10
360     PRINT #channel,str$(char);
370   END FOR char
380   CSIZE #0,0,0 : REMark restore standard spacing
390 END DEFine Prop_Print
400 :
410 DEFine PROCedure Setup_Proportional
420   REMark if using AH/JM/JS/MG limit locals to 9 only!
430   LOCal font1_length,font2_length,addr, char,wide%
440   LOCal lc1%,nc1%,lc2%,nc2%,bit,byte,a
450   :
460   REMark "font1" and "font2" must be kept global to allow font
470   REMark switching and to be able to release the heap block later
480   RESTORE 1000 : READ lc1%,nc1%
490   RESTORE 2000 : READ lc2%,nc2%
500   :
510   font1_length = 11+(9*nc1%) : IF (font1_length MOD 2)=1 THEN font1_length = font1_length+1
520   font2_length = 11+(9*nc2%) : IF (font2_length MOD 2)=1 THEN font2_length = font2_length+1
530   :
540   font1 = ALCHP(font1_length+font2_length)
550   font2 = font1 + font1_length
560   RESTORE 1000 : REMark get font 1 data
570   FOR a = 0 TO 11+(9*nc1%)-1 : READ wide% : POKE font1+a,wide%
580   RESTORE 2000 : REMark get font 2 data
590   FOR a = 0 TO 11+(9*nc2%)-1 : READ wide% : POKE font2+a,wide%
600   :
610   DIM prop%(255) : REMark proportional spacing data
620   REMark lc1% = PEEK(font1)   : REMark lowest character code in font 1
630   REMark nc1% = PEEK(font1+1) : REMark number of characters - 1 in font 1
640   REMark lc2% = PEEK(font2)   : REMark lowest character code in font 2
650   REMark nc2% = PEEK(font2+1) : REMark number of characters - 1 in font 2
660   :
670   FOR char = lc1% TO lc1%+nc1%,lc2%+1 TO lc2%+nc2%
680     IF char <= lc1%+nc1% THEN
690       addr = font1+(9*(char-lc1%))+2
700     ELSE
710       addr = font2+(9*(char-lc2%))+2
720     END IF
730     wide% = 8 : REMark default is full width char in csize 1,0
740     FOR bit = 1,2,4,8,16,32,64,128
750       FOR byte = addr+0 TO addr+8
760         IF (PEEK(byte) && bit) <> 0 THEN
770           prop%(char) = wide%
780           IF prop%(char) < 2 THEN prop%(char) = 2
790           EXIT bit
800         END IF
810       END FOR byte
820       wide% = wide% - 1
830     END FOR bit
840     IF prop%(char) < 2 THEN prop%(char) = 2 : REMark spaces=2 pixels
850   END FOR char
860   :
870   REMark other characters default to lowest character in font1
880   FOR char = 0 TO lc1%-2,lc2%+nc2%+1 TO 255 : prop%(char) = prop%(lc1%)
890 END DEFine Setup_Proportional
900 :
910 REMark data for proportional font 1
920 :
1000 DATA 31,96
1010 DATA 84,40,84,40,84,40,84,40,84
1020 DATA 0,0,0,0,0,0,0,0,0
1030 DATA 64,64,64,64,64,0,64,0,0
1040 DATA 80,80,0,0,0,0,0,0,0
1050 DATA 40,40,124,40,124,40,40,0,0
1060 DATA 56,80,80,56,20,20,56,0,0
1070 DATA 72,72,16,16,32,72,72,0,0
1080 DATA 32,80,80,32,84,72,52,0,0
1090 DATA 64,64,0,0,0,0,0,0,0
1100 DATA 32,64,64,64,64,64,32,0,0
1110 DATA 64,32,32,32,32,32,64,0,0
1120 DATA 16,84,56,16,56,84,16,0,0
1130 DATA 0,32,32,112,32,32,0,0,0
1140 DATA 0,0,0,0,0,96,96,32,64
1150 DATA 0,0,0,120,0,0,0,0,0
1160 DATA 0,0,0,0,0,96,96,0,0
1170 DATA 4,4,8,16,32,64,64,0,0
1180 DATA 56,68,76,84,100,68,56,0,0
1190 DATA 32,96,32,32,32,32,32,0,0
1200 DATA 48,72,8,8,16,32,120,0,0
1210 DATA 48,72,8,16,8,72,48,0,0
1220 DATA 8,24,40,72,120,8,8,0,0
1230 DATA 120,64,112,8,8,72,48,0,0
1240 DATA 16,32,64,112,72,72,48,0,0
1250 DATA 120,8,8,16,32,64,64,0,0
1260 DATA 48,72,72,48,72,72,48,0,0
1270 DATA 48,72,72,56,8,16,96,0,0
1280 DATA 0,0,96,96,0,96,96,0,0
1290 DATA 0,0,96,96,0,96,96,32,64
1300 DATA 8,16,32,64,32,16,8,0,0
1310 DATA 0,0,120,0,120,0,0,0,0
1320 DATA 64,32,16,8,16,32,64,0,0
1330 DATA 48,72,8,16,32,0,32,0,0
1340 DATA 56,68,92,84,92,64,56,0,0
1350 DATA 48,72,72,120,72,72,72,0,0
1360 DATA 112,72,72,112,72,72,112,0,0
1370 DATA 48,72,64,64,64,72,48,0,0
1380 DATA 112,72,72,72,72,72,112,0,0
1390 DATA 120,64,64,112,64,64,120,0,0
1400 DATA 120,64,64,112,64,64,64,0,0
1410 DATA 48,72,64,64,88,72,56,0,0
1420 DATA 72,72,72,120,72,72,72,0,0
1430 DATA 112,32,32,32,32,32,112,0,0
1440 DATA 16,16,16,16,16,80,32,0,0
1450 DATA 72,72,80,96,80,72,72,0,0
1460 DATA 64,64,64,64,64,64,120,0,0
1470 DATA 68,108,84,68,68,68,68,0,0
1480 DATA 72,72,104,88,72,72,72,0,0
1490 DATA 56,68,68,68,68,68,56,0,0
1500 DATA 112,72,72,112,64,64,64,0,0
1510 DATA 56,68,68,68,84,72,52,0,0
1520 DATA 112,72,72,112,96,80,72,0,0
1530 DATA 48,72,64,48,8,72,48,0,0
1540 DATA 124,16,16,16,16,16,16,0,0
1550 DATA 72,72,72,72,72,72,48,0,0
1560 DATA 68,68,68,68,68,40,16,0,0
1570 DATA 68,68,68,68,84,84,40,0,0
1580 DATA 68,68,40,16,40,68,68,0,0
1590 DATA 68,68,40,16,16,16,16,0,0
1600 DATA 120,8,16,32,64,64,120,0,0
1610 DATA 96,64,64,64,64,64,96,0,0
1620 DATA 64,64,32,16,8,4,4,0,0
1630 DATA 96,32,32,32,32,32,96,0,0
1640 DATA 32,80,0,0,0,0,0,0,0
1650 DATA 0,0,0,0,0,0,0,124,0
1660 DATA 16,40,32,112,32,32,120,0,0
1670 DATA 0,0,40,88,72,88,40,0,0
1680 DATA 64,64,112,72,72,72,112,0,0
1690 DATA 0,0,56,64,64,64,56,0,0
1700 DATA 8,8,56,72,72,72,56,0,0
1710 DATA 0,0,48,72,120,64,56,0,0
1720 DATA 16,40,32,112,32,32,32,0,0
1730 DATA 0,0,56,72,72,72,56,8,48
1740 DATA 64,64,112,72,72,72,72,0,0
1750 DATA 64,0,64,64,64,64,64,0,0
1760 DATA 32,0,32,32,32,32,32,32,64
1770 DATA 64,64,72,80,96,80,72,0,0
1780 DATA 64,64,64,64,64,64,64,0,0
1790 DATA 0,0,104,84,84,84,84,0,0
1800 DATA 0,0,112,72,72,72,72,0,0
1810 DATA 0,0,56,68,68,68,56,0,0
1820 DATA 0,0,112,72,72,72,112,64,64
1830 DATA 0,0,56,72,72,72,56,8,8
1840 DATA 0,0,80,104,64,64,64,0,0
1850 DATA 0,0,48,64,48,8,48,0,0
1860 DATA 32,32,112,32,32,32,16,0,0
1870 DATA 0,0,72,72,72,72,56,0,0
1880 DATA 0,0,72,72,72,48,16,0,0
1890 DATA 0,0,68,68,68,84,40,0,0
1900 DATA 0,0,80,32,32,32,80,0,0
1910 DATA 0,0,72,72,72,72,56,8,48
1920 DATA 0,0,120,16,32,64,120,0,0
1930 DATA 16,32,32,64,32,32,16,0,0
1940 DATA 64,64,64,64,64,64,64,0,0
1950 DATA 64,32,32,16,32,32,64,0,0
1960 DATA 40,80,0,0,0,0,0,0,0
1970 DATA 56,68,92,100,92,68,56,0,0
1980 :
1990 REMark data for proportional font 2
2000 DATA 127,64
2010 DATA 84,40,84,40,84,40,84,40,84
2020 DATA 72,0,40,88,72,88,40,0,0
2030 DATA 40,80,0,56,72,88,40,0,0
2040 DATA 16,40,16,56,72,88,40,0,0
2050 DATA 16,32,48,72,120,64,56,0,0
2060 DATA 68,0,56,68,68,68,56,0,0
2070 DATA 20,40,0,56,68,68,56,0,0
2080 DATA 0,0,60,76,84,100,120,0,0
2090 DATA 72,0,0,72,72,72,56,0,0
2100 DATA 0,0,56,64,64,64,56,16,32
2110 DATA 40,80,0,112,72,72,72,0,0
2120 DATA 0,0,120,20,56,80,60,0,0
2130 DATA 0,0,40,84,88,80,44,0,0
2140 DATA 16,32,40,88,72,88,40,0,0
2150 DATA 64,32,40,88,72,88,40,0,0
2160 DATA 16,40,0,56,72,88,40,0,0
2170 DATA 72,0,48,72,120,64,56,0,0
2180 DATA 64,32,48,72,120,64,56,0,0
2190 DATA 16,40,48,72,120,64,56,0,0
2200 DATA 80,0,0,32,32,32,16,0,0
2210 DATA 32,64,0,64,64,64,32,0,0
2220 DATA 64,32,0,32,32,32,16,0,0
2230 DATA 32,80,0,32,32,32,16,0,0
2240 DATA 8,16,56,68,68,68,56,0,0
2250 DATA 32,16,56,68,68,68,56,0,0
2260 DATA 16,40,0,56,68,68,56,0,0
2270 DATA 16,32,72,72,72,72,56,0,0
2280 DATA 32,16,72,72,72,72,56,0,0
2290 DATA 16,40,0,72,72,72,56,0,0
2300 DATA 48,72,72,80,72,72,80,64,64
2310 DATA 0,16,56,80,80,80,56,16,0
2320 DATA 68,68,40,16,124,16,56,0,0
2330 DATA 64,32,0,0,0,0,0,0,0
2340 DATA 68,16,40,68,124,68,68,0,0
2350 DATA 20,40,16,40,68,124,68,0,0
2360 DATA 16,40,16,40,68,124,68,0,0
2370 DATA 8,16,120,64,120,64,120,0,0
2380 DATA 68,56,68,68,68,68,56,0,0
2390 DATA 20,40,56,68,68,68,56,0,0
2400 DATA 52,68,76,84,100,68,88,0,0
2410 DATA 72,0,72,72,72,72,48,0,0
2420 DATA 48,72,64,64,64,72,48,16,32
2430 DATA 56,0,68,100,84,76,68,0,0
2440 DATA 60,72,72,124,72,72,76,0,0
2450 DATA 60,72,72,76,72,72,60,0,0
2460 DATA 0,0,36,88,72,88,36,0,0
2470 DATA 56,68,64,56,68,68,56,0,0
2480 DATA 56,68,68,124,68,68,56,0,0
2490 DATA 96,16,16,16,40,72,68,0,0
2500 DATA 0,0,72,72,72,104,88,64,64
2510 DATA 0,0,60,104,40,40,40,0,0
2520 DATA 16,16,56,84,84,84,56,16,16
2530 DATA 64,0,64,64,64,64,64,0,0
2540 DATA 16,0,16,32,64,68,56,0,0
2550 DATA 24,36,112,32,112,36,24,0,0
2560 DATA 56,68,64,56,68,56,4,68,56
2570 DATA 0,68,56,68,68,56,68,0,0
2580 DATA 0,20,40,80,40,20,0,0,0
2590 DATA 0,80,40,20,40,80,0,0,0
2600 DATA 32,80,32,0,0,0,0,0,0
2610 DATA 0,16,0,124,0,16,0,0,0
2620 DATA 0,0,16,48,124,48,16,0,0
2630 DATA 0,0,16,24,124,24,16,0,0
2640 DATA 0,16,56,124,16,16,16,16,0
2650 DATA 0,16,16,16,16,124,56,16,0
